Subject: Re: ''git submodule sync'' should not add uninitialized submodules to .git/config

From: Jens Lehmann <[email-masked]>
Date: Fri, 24 Jun 2011 08:17:30 +0200

Am 24.06.2011 01:10, schrieb Andreas Köhler:
> There are two minor issues for me left.
> (1) The man page of submodule sync talks about "all submodules" and not
> "registered submodules". I treated it as "subsequent init" and
> personally do not restrict the list of submodules, simply because my
> build would not work without them.

While investigating this I stumbled across that too, will post a patch.

> (2) It is confusing to have registered submodules in .git/config without
> a matching gitlink. Say, you switch between branch a1 with a submodule s
> with url u1, to a branch without s, you git clean -xdff (url u1 is still
> in .git/config, right?), and then to a branch a2 with s pointing to url
> u2. This bugged me.

I think that is ok, because that way git remembers that the user cares
about submodule s even when he switches to a branch where s doesn't
exist. And the documentation is pretty clear that you'll have to use
"git submodule sync" to update the url itself from u1 to u2 when needed.